# Shell completion

The Substrate cli command supports shell auto-completion. For this to work, you will need to run the
completion script matching your build and system.

Assuming you built a release version using `cargo build --release` and use `bash` run the following:

`source target/release/completion-scripts/substrate.bash`

You can find completion scripts for:
- bash
- fish
- zsh
- elvish
- powershell

To make this change persistent, you can proceed as follows:

```shell
COMPL_DIR=$HOME/.completion
mkdir -p $COMPL_DIR
cp -f target/release/completion-scripts/substrate.bash $COMPL_DIR/
echo "source $COMPL_DIR/substrate.bash" >> $HOME/.bash_profile
source $HOME/.bash_profile
```

When you build a new version of Substrate, the following will ensure your auto-completion script matches the current binary:

```shell
COMPL_DIR=$HOME/.completion
mkdir -p $COMPL_DIR
cp -f target/release/completion-scripts/substrate.bash $COMPL_DIR/
source $HOME/.bash_profile
```
